<?php
namespace Mittwald\Typo3Forum\Domain\Repository\Stats;

/*                                                                    - *
 *  COPYRIGHT NOTICE                                                    *
 *                                                                      *
 *  (c) 2015 Mittwald CM Service GmbH & Co KG                           *
 *           All rights reserved                                        *
 *                                                                      *
 *  This script is part of the TYPO3 project. The TYPO3 project is      *
 *  free software; you can redistribute it and/or modify                *
 *  it under the terms of the GNU General Public License as published   *
 *  by the Free Software Foundation; either version 2 of the License,   *
 *  or (at your option) any later version.                              *
 *                                                                      *
 *  The GNU General Public License can be found at                      *
 *  http://www.gnu.org/copyleft/gpl.html.                               *
 *                                                                      *
 *  This script is distributed in the hope that it will be useful,      *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of      *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
 *  GNU General Public License for more details.                        *
 *                                                                      *
 *  This copyright notice MUST APPEAR in all copies of the script!      *
 *                                                                      */

use TYPO3\CMS\Extbase\Persistence\QueryInterface;
use TYPO3\CMS\Extbase\Persistence\Repository;

class SummaryRepository extends Repository {

	/**
	 * The amount of types the summary includes (post,topic,user = 3)
	 * @var int
	 */
	private $summaryItems = 3;

	/**
	 * Get the latest items of the summary
	 * @return \Mittwald\Typo3Forum\Domain\Model\Stats\Summary[]
	 */
	public function findLatestSummaryItems() {
		$query = $this->createQuery();
		$ordering = [
			'tstamp' => QueryInterface::ORDER_DESCENDING,
			'type' => QueryInterface::ORDER_ASCENDING,
		];
		$query->setOrderings($ordering);
		$query->setLimit($this->summaryItems);

		return $query->execute();
	}

}